package org.apache.commons.lang3;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.lang.reflect.Array;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.BiConsumer;
import java.util.function.BinaryOperator;
import java.util.function.Function;
import java.util.function.Supplier;
import java.util.stream.Collector;
import org.apache.commons.lang3.Streams;

@Deprecated
public class ArrayCollector<O> implements Collector<O, List<O>, O[]> {
  private static final Set<Collector.Characteristics> characteristics = Collections.emptySet();
  
  private final Class<O> elementType;
  
  public ArrayCollector(Class<O> elementType) {
    this.elementType = elementType;
  }
  
  public Supplier<List<O>> supplier() {
    return java.util.ArrayList::new;
  }
  
  public BiConsumer<List<O>, O> accumulator() {
    return List::add;
  }
  
  public BinaryOperator<List<O>> combiner() {
    return (left, right) -> {
        left.addAll(right);
        return left;
      };
  }
  
  public Function<List<O>, O[]> finisher() {
    return list -> {
        O[] array = (O[])Array.newInstance(this.elementType, list.size());
        return list.toArray((Object[])array);
      };
  }
  
  public Set<Collector.Characteristics> characteristics() {
    return characteristics;
  }
}
